/***********************************************************************************************************************
 *
 * blueBill Mobile - Android - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it/mobile
 * SCM: https://java.net/hg/bluebill-mobile~android-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.observation.impl;

import javax.annotation.Nonnull;
import it.tidalwave.role.PlainTextRenderable;
import it.tidalwave.observation.ObservationItem;
import static it.tidalwave.role.PlainTextRenderable.PlainTextRenderable;
import static it.tidalwave.bluebill.taxonomy.mobile.Taxon.Taxon;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class ObservationItemPlainTextRenderable extends ObservationItemTextRenderableSupport implements PlainTextRenderable
  {
    public ObservationItemPlainTextRenderable (final @Nonnull ObservationItem observationItem) 
      {
        super(observationItem);
      }
    
    @Nonnull
    public String render (final @Nonnull Object... args)
      {
        final StringBuilder builder = new StringBuilder();
        observationItem.getObservable().as(Taxon).as(PlainTextRenderable).renderTo(builder);
        builder.append(renderArgs(args));
        return builder.toString();
      }
  }
