/***********************************************************************************************************************
 *
 * blueBill Mobile - Android - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it/mobile
 * SCM: https://java.net/hg/bluebill-mobile~android-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.observation.report;

import javax.annotation.concurrent.NotThreadSafe;
import javax.annotation.Nonnull;
import it.tidalwave.geo.Range;
import it.tidalwave.observation.ObservationVisitorSupport;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.ToString;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@NotThreadSafe @RequiredArgsConstructor @ToString(exclude={"buffer"})
public abstract class ReportGenerator extends ObservationVisitorSupport
  {
    protected static final Class<Range> Range = Range.class; // FIXME: move to Range

    @Nonnull @Getter
    private final String name;
    
    @Nonnull @Getter
    private final String mimeType;
    
    protected final StringBuilder buffer = new StringBuilder();

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Nonnull
    public final String getMessage()
      {
        return buffer.toString();
      }
  }
